import itertools as it
import math as m

def d(p1, p2):
    return m.sqrt((p1[0] - p2[0])**2 + (p1[1] - p2[1])**2)

def t_dist(path):
    dist = 0
    for i in range(len(path) - 1):
        dist += d(path[i], path[i + 1])
    return dist

n = int(input())
locs = [tuple(map(int, input().split())) for _ in range(n)]

min_d = float('inf')

for perm in it.permutations(locs):
    dist = t_dist(perm)
    if dist < min_d:
        min_d = dist

print(f"{min_d:.12f}")